'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.DefaultOptions = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _class,
    _temp,
    _arguments = arguments;

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _vinylRead = require('vinyl-read');

var _vinylRead2 = _interopRequireDefault(_vinylRead);

var _convertVinylToVfile = require('convert-vinyl-to-vfile');

var _convertVinylToVfile2 = _interopRequireDefault(_convertVinylToVfile);

var _skypagerUtil = require('skypager-util');

var _document = require('../document');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _Object = Object;
var defineProperty = _Object.defineProperty;
var DefaultOptions = exports.DefaultOptions = {
  patterns: _document.DefaultPatterns
};

var DocumentImporter = (_temp = _class = (function () {
  (0, _createClass3.default)(DocumentImporter, null, [{
    key: 'create',
    value: function create(basePath) {
      var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      if (typeof options === 'string') {
        options = {
          patterns: [options],
          basePath: basePath
        };
      }

      if ((0, _isArray2.default)(options)) {
        options = {
          patterns: options,
          basePath: basePath
        };
      }

      var importer = new DocumentImporter(basePath, (0, _extends3.default)({
        basePath: basePath
      }, options));

      return importer;
    }
  }]);

  function DocumentImporter() {
    var basePath = arguments.length <= 0 || arguments[0] === undefined ? process.cwd() : arguments[0];
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    (0, _classCallCheck3.default)(this, DocumentImporter);

    (0, _skypagerUtil.mixinPropertyUtils)(this);

    if (typeof basePath !== 'string') {
      throw 'Document Importers must be created with a basePath path';
    }

    this.hide('root', basePath);
    this.hide('base', basePath);
    this.hide('basePath', basePath);

    this.hide('options', (0, _extends3.default)({}, DefaultOptions, options));

    this.hide('patterns', options.patterns);

    var status = 'CREATED';

    defineProperty(this, 'status', {
      configurable: false,
      get: function get() {
        return status;
      },
      set: function set(newValue) {
        return status = newValue;
      }
    });
  }

  (0, _createClass3.default)(DocumentImporter, [{
    key: 'readFilesSync',
    value: function readFilesSync() {
      var includeContents = arguments.length <= 0 || arguments[0] === undefined ? false : arguments[0];

      return _vinylRead2.default.sync(this.patterns, (0, _extends3.default)({
        basePath: this.basePath,
        read: includeContents === true
      }, this.options)).map(function (vinyl) {
        return (0, _convertVinylToVfile2.default)(vinyl);
      });
    }
  }, {
    key: 'readFiles',
    value: (function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var includeContents = _arguments.length <= 0 || _arguments[0] === undefined ? false : _arguments[0];

        var _files;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return (0, _vinylRead2.default)(this.patterns, (0, _extends3.default)({
                  basePath: this.basePath,
                  read: includeContents === true
                }, this.options));

              case 2:
                _files = _context.sent;
                return _context.abrupt('return', _files.map(function (vinyl) {
                  return (0, _convertVinylToVfile2.default)(vinyl);
                }));

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function readFiles() {
        return _ref.apply(this, arguments);
      }

      return readFiles;
    })()
  }, {
    key: 'fileWrappersSync',
    get: function get() {
      return _vinylRead2.default.sync(this.patterns, {
        basePath: this.basePath,
        read: false
      }).map(function (vinyl) {
        return (0, _convertVinylToVfile2.default)(vinyl);
      });
    }
  }, {
    key: 'fileWrappers',
    get: function get() {
      return (0, _vinylRead2.default)(this.patterns, {
        basePath: this.basePath, read: false
      }).map(function (vinyl) {
        return (0, _convertVinylToVfile2.default)(vinyl);
      });
    }
  }]);
  return DocumentImporter;
})(), _class.patterns = _document.DefaultPatterns, _temp);
exports.default = DocumentImporter;