module.exports = function (repl) {
  repl.context.docs = require('./src').mount(process.cwd(), {
    ignore: ['lib/','test/fixtures/**']
  })

  repl.context.doc = repl.context.docs.query.documents(doc => doc.id === 'src/collection/index')[0]

  repl.context.DocumentImporter = require('./lib/importer').default
  repl.context.Collection = require('./lib/Collection').default

  try {
    repl.context.importer = DocumentImporter.create(process.cwd(), {
      patterns: ['**/*.js', '!node_modules/**']
    })

    repl.context.collection = new Collection({
      type: 'documents',
      base: process.cwd() + '/test/fixtures'
    })

  } catch(error) {
    console.log('Error adding importer to the repl context', error.message)
    console.log()
    repl.context.errorStack = error.stack

    setTimeout((() => repl.displayPrompt()), 15)
  }
}
