import DocumentImporter from '.'
import { join } from 'path'

describe('Skypager Document Importer', function() {
  it('loads all of the files', function(done){
    const importer = DocumentImporter.create(
      join(process.cwd(), "test", 'fixtures'),
      ['**/*.md', '!node_modules/**']
    )

    importer.readFiles(false).then((files) => {
      files.should.not.be.empty
      done()
    })
    .catch((error) => done(error))
  })

  it('Can load files synchronously', function() {
    const importer = DocumentImporter.create(
      join(process.cwd(), "test", 'fixtures', 'testcases'),
      {patterns: ['**/*.md', '!node_modules/**']}
    )

    const files = importer.readFilesSync()

    files.should.be.an('array')
    files.should.not.be.empty
    files[0].should.be.an('object')
      .that.has.property('path').that.is.not.empty
  })
})
